/*
    prof. Constantin Galatan
    Programare dinamica
    Complexitate: O(n*n)
*/
#include <fstream>
#include <algorithm>
#include <cstring>
using namespace std;


ifstream fin("nuz.in");
ofstream fout("nuz.out");

const int MaxN = 1000005, Mod = 30011;

int c[MaxN]; // c[i] nr posibilitati de a construi un cuvant de lungime FIX i,
             // a.i. in interior nici o secv formata din litere identice sa nu depaseasca lung k
			 // si care se termina cu o secv de lungime j (1 <= j <= k) de litere identice

int Count(int n, int k);

int main()
{
	int n, k;
	fin >> n >> k;

	fout << ((Count(n, k) - Count(n, k - 1) + Mod) % Mod);

	fin.close();
	fout.close();
}

int Count(int n, int k)
{
	memset(c, 0, sizeof(c));
	c[0] = 1;
	for (int i = 1; i <= n; ++i)
		for (int j = 1; j <= min(i, k); ++j)
		{
			c[i] += 25 * c[i - j];
			c[i] %= Mod;
		}

	int cnt {0};
	for (int i = 0; i <= n; ++i)
		cnt = (cnt + c[i]) % Mod;
	return cnt;
}
