/*
    prof. Constantin Galatan
    Memoizare
    Complexitate: O(nxn)
*/
#include <fstream>
#include <algorithm>
#include <cstring>
using namespace std;

ifstream fin("nuz.in");
ofstream fout("nuz.out");

const int Mod = 30011;

short c[1001][1001][2];  // c[i][j][ok] - nr de cuvinte care contin secvente maximale
                          // incepand cu pozitia i (1 <= i <= n), si care se termina o secventa de lungime j
                          // formata din litere identice si ok = true daca
                          // a fost intalnita o secventa maximala de lungime k in intervalul [1, i]
int n, k;

int Count(int i, int j, bool got);

int main()
{
	fin >> n >> k;

	long long res = 0;
	memset(c, -1, sizeof(c));
	for (int i = 0; i <= n - k; ++i)
		res = (res + 25 * Count(i + 1, 1, false)) % Mod;

	fout << res;

	fin.close();
	fout.close();
}

int Count(int i, int j, bool got)
{
	if (i >= n)
		return got || j >= k;

	short& r = c[i][j][got];
	if (r != -1) return r;
	if (j == k)
		return r = (25 * Count(i + 1, 1, true)) % Mod; // incepe o noua secventa repetabila
	return r = (Count(i + 1, j + 1, got)               // continuam cu litera anterioara
	           + 25 * Count(i + 1, 1, got)) % Mod;     // sau incepem o noua secventa  (25 posibilitati pentru prima litera)
}
